VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   2910
   ClientLeft      =   2625
   ClientTop       =   3495
   ClientWidth     =   4905
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   2910
   ScaleWidth      =   4905
   Begin VB.CommandButton cmdConvert 
      Caption         =   "Convert"
      Default         =   -1  'True
      Height          =   495
      Left            =   1800
      TabIndex        =   1
      Top             =   840
      Width           =   1215
   End
   Begin VB.TextBox txtInput 
      Height          =   285
      Left            =   120
      TabIndex        =   0
      Text            =   "to: ""mr/mrs pat o'connor of i.b.m (europe)"""
      Top             =   360
      Width           =   4695
   End
   Begin VB.Label lblProperCase 
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   120
      TabIndex        =   6
      Top             =   2520
      Width           =   4695
   End
   Begin VB.Label Label1 
      Caption         =   "ProperCase"
      Height          =   255
      Index           =   2
      Left            =   120
      TabIndex        =   5
      Top             =   2280
      Width           =   1335
   End
   Begin VB.Label lblStrConv 
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   1800
      Width           =   4695
   End
   Begin VB.Label Label1 
      Caption         =   "StrConv"
      Height          =   255
      Index           =   1
      Left            =   120
      TabIndex        =   4
      Top             =   1560
      Width           =   1335
   End
   Begin VB.Label Label1 
      Caption         =   "Input"
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   3
      Top             =   120
      Width           =   1335
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub cmdConvert_Click()
    lblStrConv.Caption = StrConv(txtInput.Text, vbProperCase)
    lblProperCase.Caption = LwrToUpprCase(txtInput.Text)
End Sub
' subroutine to normalize 1 piece of data Capitalize
'           Inputs:  char label                             10/29/91
'          Outputs:  Normalized Label
'
' Rules Cap char after [ ][>][-][.][/][#][0-9][&][Mc][,][(],[\],[|]
'       Cap char after [!][@][$][%][^][*][+][=]["]['(not s)]
'       abbreviations [po][nw][ne][sw][se][ii] are capitalized
'       abbreviations [st][th][nd][rd][c/o]    are not capitalized
'               words [of][and]                are not capitalized
Public Function LwrToUpprCase(ByVal edit$) As String
    Dim A$, b$, c$, I%
    On Error Resume Next

    If Len(Trim(edit$)) = 0 Then
        LwrToUpprCase = edit$
        Exit Function
    End If

    edit$ = edit$ + Space$(3)       'end of word match ???
    Mid$(edit$, 1, 1) = UCase$(Mid$(edit$, 1, 1)) 'cap first char
    If Mid$(edit$, 1, 3) = "Po " Then
        Mid$(edit$, 1, 3) = "PO " 'PO Box cap
    End If
    b$ = "NwNeSwSeIi"       'NW NE SW SE II
    If Mid$(edit$, 1, 2) = "Mc" Then
        Mid$(edit$, 3, 1) = UCase$(Mid$(edit$, 3, 1))
    End If
    If Mid$(edit$, 1, 1) > Chr$(47) And Mid$(edit$, 1, 1) < Chr$(58) Then
        Mid$(edit$, 2, 1) = UCase$(Mid$(edit$, 2, 1)) 'nos 0 - 9
    End If
    c$ = " >-./#&,(!@$%^*+=\|" & Chr(34)
    If InStr(c$, Mid$(edit$, 1, 1)) > 0 Then
        Mid$(edit$, 2, 1) = UCase$(Mid$(edit$, 2, 1))
    End If
    For I% = 2 To Len(edit$)
        If InStr(b$, Mid$(edit$, I%, 2)) > 0 Then
            If Mid$(edit$, I% - 1, 1) = " " And Mid$(edit$, I% + 2, 1) = " " Then
                Mid$(edit$, I%, 2) = UCase$(Mid$(edit$, I%, 2))
            End If
            I% = I% + 2
        End If
        If Mid$(edit$, I%, 4) = " of " Then 'dont cap word "of"
            I% = I% + 2
            GoTo skipcapchar
        ElseIf Mid$(edit$, I%, 5) = " and " Then 'dont cap word "and"
            I% = I% + 3
            GoTo skipcapchar
        
        ElseIf Mid$(edit$, I%, 5) = " c/o " Then 'dont cap abbrev c/o
            I% = I% + 3
            GoTo skipcapchar
        End If
        If InStr(c$, Mid$(edit$, I%, 1)) > 0 And I% < Len(edit$) Then
            Mid$(edit$, I% + 1, 1) = UCase(Mid$(edit$, I% + 1, 1))
        End If
        If Mid$(edit$, I%, 1) = Chr$(39) And Mid$(edit$, I% + 1, 1) <> "s" Then
            Mid$(edit$, I% + 1, 1) = UCase$(Mid$(edit$, I% + 1, 1)) 'O'Malley's
        End If
        If Mid$(edit$, I%, 2) = "Mc" Then
            Mid$(edit$, I% + 2, 1) = UCase$(Mid$(edit$, I% + 2, 1))
        End If
        If InStr("0123456789", Mid$(edit$, I%, 1)) > 0 Then 'nos 0-9
            A$ = Mid$(edit$, I% + 1, 2)
            If A$ <> "st" And A$ <> "th" And A$ <> "nd" And A$ <> "rd" Then
                Mid$(edit$, I% + 1, 1) = UCase$(Mid$(edit$, I% + 1, 1)) 'no's 0-9
            End If
        End If
skipcapchar:
    Next I%
    edit$ = RTrim$(edit$) 'trim space added earlier

    LwrToUpprCase = edit$
End Function
